CREATE OR REPLACE
PROCEDURE CONCLUI_MIGRACAO_OL(P_STATUS         OUT VARCHAR2,
                              P_NRSEQRUPTURAOL IN RUPTURAOL.NRSEQRUPTURAOL%TYPE DEFAULT NULL,
                              P_CDFILIAL       IN RUPTURAOL.CDFILIAL%TYPE DEFAULT NULL)
IS
  V_CONTA_ITEM          NUMERIC := 0;
  V_CONTA_ITEMRUP       NUMERIC := 0;
  V_CONTA_PORTAL        NUMERIC := 0;
  V_CONTA_FORN          NUMERIC := 0;
  V_DSJUSTOPER          MOVOPSOL.DSJUSTOPER%TYPE;
  V_DSRDMUSLITAF        VARCHAR2(50);
  V_DSENDUSLITAF        VARCHAR2(50);
  V_DSNMUSULITAF        VARCHAR2(50);
  V_DSMETUSLITAF        VARCHAR2(250);
  V_CDOPELOGITAF        VARCHAR2(12);
  V_NMOPERADOR          OPERADOR.NMOPERADOR%TYPE;
  V_QTSOLIPRODRUP       ITEMSOLI.QTSOLIPROD%TYPE;
  V_QTSOLIPROD          ITEMSOLI.QTSOLIPROD%TYPE;
  V_CDPRODESTORUP       PRODUTO.CDPRODUTO%TYPE;
  V_VRFATOCONVRUP       PRODUTO.VRFATOCONV%TYPE;
  V_QTANTOPER           ITEMSOLI.QTSOLIPROD%TYPE;
  V_QTDEPOPER           ITEMSOLI.QTSOLIPROD%TYPE;
  V_ITEM_NOVA_AP        NUMERIC := 0;
  V_CDPRODINI           PRODUTO.CDARVPROD%TYPE;
  V_CDPRODFIN           PRODUTO.CDARVPROD%TYPE;
  V_DTENTRINI           DATE;
  V_DTENTRFIN           DATE;
  V_CDFILCENTCMP        VARCHAR2(4);
  V_LISTA_FILIAL        VARCHAR2(2000) := '';
  V_NRSEQAPUR           VARCHAR2(10);
  V_ROWSAFFECT          VARCHAR2(10);
  V_LISTA_COMP          VARCHAR2(2000) := '';
  V_SEM_ERRO            VARCHAR2(1);
  V_CHAVE               VARCHAR2(21) := '_';
  V_LISTA_AF            VARCHAR2(2000) := '';
  V_LISTA_TAF           VARCHAR2(2000) := '';
  V_ENVIOAFFORN         VARCHAR2(20);
  V_ERROR               VARCHAR2(2000) := '';
  V_NRLOGRUPTURAOLAUT   VARCHAR2(10);
  V_NRSEQRUPTURAOL      RUPTURAOL.NRSEQRUPTURAOL%TYPE;
  V_CDFILIAL            RUPTURAOL.CDFILIAL%TYPE;
  V_LISTA_ENVIOAFFORN   VARCHAR2(1000) := '_';
  V_AFS_GERADAS         NUMERIC := 0;
  V_CONTA_PORTALT       NUMERIC := 0;
  V_DSURLCONCLAUTRUPOL  PARASUPRI.DSURLCONCLAUTRUPOL%TYPE;
  V_RETORNO             VARCHAR2(1000);
BEGIN
   BEGIN
      FOR C_PARASUPRI IN (SELECT TO_CHAR(HRCONCLAUTRUPOL, 'HH24:MI:SS') HRCONCLAUTRUPOL,
                                 DSURLCONCLAUTRUPOL
                            FROM PARASUPRI
                           WHERE NVL(HRCONCLAUTRUPOL, '01/01/2000') <> '01/01/2000'
                             AND TO_CHAR(HRCONCLAUTRUPOL, 'HH24:MI:SS')
                         BETWEEN  TO_CHAR(SYSDATE - 60/(24*60),'HH24:MI:SS') AND TO_CHAR(SYSDATE + 60/(24*60),'HH24:MI:SS')
      ) LOOP
         WEBTUNNING(V_DSENDUSLITAF, V_DSNMUSULITAF, V_DSRDMUSLITAF, V_DSMETUSLITAF, V_CDOPELOGITAF);
         V_DSURLCONCLAUTRUPOL := C_PARASUPRI.DSURLCONCLAUTRUPOL;
         FOR C_RUPTURAOL IN (SELECT RUPTURAOL.NRSEQRUPTURAOL, RUPTURAOL.CDFILIAL, RUPTURAOL.CDOPERADOR
                               FROM RUPTURAOL
                              WHERE RUPTURAOL.DTRUPTURAOL BETWEEN SYSDATE-30 AND SYSDATE
                                AND NVL(RUPTURAOL.IDSITUACAO, 'P') = 'P'
                                AND RUPTURAOL.NRSEQRUPTURAOL = NVL(P_NRSEQRUPTURAOL, RUPTURAOL.NRSEQRUPTURAOL)
                                AND RUPTURAOL.CDFILIAL       = NVL(P_CDFILIAL, RUPTURAOL.CDFILIAL)
                                AND EXISTS(SELECT 1
                                             FROM ITEMAUTF
                                            WHERE ITEMAUTF.NRSEQRUPTURAOL = RUPTURAOL.NRSEQRUPTURAOL
                                              AND ITEMAUTF.IDITEMRUPTURA  = 'S'
                                              AND NVL(ITEMAUTF.QTATENDPEDOL, 0) = 0)
                            ORDER BY RUPTURAOL.NRSEQRUPTURAOL) LOOP
            V_LISTA_ENVIOAFFORN := '_';
            V_CDOPELOGITAF := C_RUPTURAOL.CDOPERADOR;
            V_ITEM_NOVA_AP := 0;
            V_NRLOGRUPTURAOLAUT := SEQ_NRLOGRUPTURAOLAUT.NEXTVAL;
            INSERT
              INTO LOGRUPTURAOLAUT(NRLOGRUPTURAOLAUT, NRSEQRUPTURAOL, CDFILIAL, DTOPERACAO)
            VALUES (V_NRLOGRUPTURAOLAUT, C_RUPTURAOL.NRSEQRUPTURAOL, C_RUPTURAOL.CDFILIAL, SYSDATE);
            V_NRSEQRUPTURAOL := C_RUPTURAOL.NRSEQRUPTURAOL;
            V_CDFILIAL       := C_RUPTURAOL.CDFILIAL;
            SELECT COUNT(1)
              INTO V_CONTA_ITEM
              FROM ITEMAUTF
             WHERE ITEMAUTF.NRSEQRUPTURAOL = C_RUPTURAOL.NRSEQRUPTURAOL
               AND ITEMAUTF.IDITEMRUPTURA  = 'S'
               AND NVL(ITEMAUTF.QTATENDPEDOL, 0) = 0
               AND NVL(ITEMAUTF.IDTPGERARUP, '0') = '0';
            SELECT MAX(NVL(CDFILCENTCMP, CDFILIAL))
              INTO V_CDFILCENTCMP
              FROM FILIAL
             WHERE CDFILIAL = C_RUPTURAOL.CDFILIAL;
            IF V_CONTA_ITEM = 0 THEN
               FOR C_ITEM IN (SELECT ITEMAUTF.CDFILDEST, ITEMAUTF.CDFILLANC, ITEMAUTF.NRAUTOFORN,
                                     ITEMAUTF.CDPRODUTO, ITEMAUTF.CDMARCA, ITEMAUTF.DTPROGENTAF,
                                     ITEMAUTF.CDPRODRUP, ITEMAUTF.CDMARCARUP, ITEMAUTF.QTNOVAPROGAF,
                                     ITEMAUTF.VRPREUNIRUP, ITEMAUTF.DTENTRITMSOL, PRODUTO.CDPRODESTO,
                                     ITEMAUTF.IDTPGERARUP, PRODUTO.VRFATOCONV, PRODUTO.CDARVPROD
                                FROM ITEMAUTF, PRODUTO
                               WHERE ITEMAUTF.CDPRODUTO = PRODUTO.CDPRODUTO
                                 AND ITEMAUTF.NRSEQRUPTURAOL = C_RUPTURAOL.NRSEQRUPTURAOL
                               ORDER BY ITEMAUTF.CDFILDEST, ITEMAUTF.IDTPGERARUP) LOOP
                  IF C_ITEM.IDTPGERARUP = 'A' THEN
                     IF ((LENGTH(C_ITEM.CDPRODRUP) > 0)  AND (LENGTH(C_ITEM.CDMARCARUP) > 0)  AND
                         (C_ITEM.QTNOVAPROGAF > 0)       AND (C_ITEM.VRPREUNIRUP > 0)) THEN
                        /*Consulta existencia de item de ruptura na AF origem*/
                        SELECT COUNT(1)
                          INTO V_CONTA_ITEMRUP
                          FROM ITEMAUTF
                         WHERE CDFILDEST     = C_ITEM.CDFILDEST
                           AND CDFILLANC     = C_ITEM.CDFILLANC
                           AND NRAUTOFORN    = C_ITEM.NRAUTOFORN
                           AND CDMARCA       = C_ITEM.CDMARCARUP
                           AND CDPRODUTO     = C_ITEM.CDPRODRUP
                           AND DTPROGENTAF   = C_ITEM.DTPROGENTAF;
                        IF V_CONTA_ITEMRUP = 0 THEN
                            /*Atualiza item de ruptura na AF origem*/
                            /*INCLUIR ATUALIZARO PARA RESERVAR ITEM*/
                           INSERT
                             INTO ITEMAUTF(CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO,
                                           DTPROGENTAF, CDSEGMARCA, NRPARCITMAF, QTPROGENTAF, VRPREUNIAF,
                                           VRPERDESAF, VRDESCITMAF, TXOBSITMAF, DTENTRITMSOL, NRSEQRUPTURAOL,
                                           CDFILDESTORIG, CDFILLANCORIG, NRAUTOFORNORIG, CDMARCAORIG, CDPRODUTOORIG, DTPROGENTAFORIG,
                                           IDITMSEPARADO, CDRASTRITM)
                           SELECT CDFILDEST, CDFILLANC, NRAUTOFORN, C_ITEM.CDMARCARUP, C_ITEM.CDPRODRUP,
                                  DTPROGENTAF, CDSEGMARCA, '00', C_ITEM.QTNOVAPROGAF, C_ITEM.VRPREUNIRUP,
                                  VRPERDESAF, VRDESCITMAF, TXOBSITMAF, DTENTRITMSOL, NRSEQRUPTURAOL,
                                  CDFILDEST, CDFILLANC, NRAUTOFORN, CDMARCA, CDPRODUTO, DTPROGENTAF,
                                  'S', CDRASTRITM
                             FROM ITEMAUTF I
                             WHERE I.CDFILDEST   = C_ITEM.CDFILDEST
                               AND I.CDFILLANC   = C_ITEM.CDFILLANC
                               AND I.NRAUTOFORN  = C_ITEM.NRAUTOFORN
                               AND I.CDPRODUTO   = C_ITEM.CDPRODUTO
                               AND I.CDMARCA     = C_ITEM.CDMARCA
                               AND I.DTPROGENTAF   = C_ITEM.DTPROGENTAF;
                        ELSE
                        /*Atualiza item de ruptura na AF origem*/
                        UPDATE ITEMAUTF
                           SET QTPROGENTAF   = QTPROGENTAF + C_ITEM.QTNOVAPROGAF,
                               IDITMSEPARADO = 'S'
                         WHERE CDFILDEST     = C_ITEM.CDFILDEST
                           AND CDFILLANC     = C_ITEM.CDFILLANC
                           AND NRAUTOFORN    = C_ITEM.NRAUTOFORN
                           AND CDMARCA       = C_ITEM.CDMARCARUP
                           AND CDPRODUTO     = C_ITEM.CDPRODRUP
                           AND DTPROGENTAF   = C_ITEM.DTPROGENTAF;
                        END IF;
                        /*Pesquisa de itens de solicitacao origem*/
                        SELECT MAX(CDPRODESTO), MAX(VRFATOCONV)
                           INTO V_CDPRODESTORUP, V_VRFATOCONVRUP
                           FROM PRODUTO
                          WHERE CDPRODUTO = C_ITEM.CDPRODRUP;
                         FOR C_ITMSOL_ORIG IN(SELECT ITEMSOLI.CDFILSOLI, ITEMSOLI.CDFILLAN, ITEMSOLI.NRSOLICMP, ITEMSOLI.CDPRODUTO,
                                                     ITEMSOLI.DTPROGENTR, ITEMSOLI.QTSOLIPROD, ITEMSOLI.DTUTILIZA, ITEMSOLI.IDITMCONS,
                                                     ITEMSOLI.TXOBSITMSOL, ITEMSOLI.IDBAIXITMSOL, ITEMSOLI.QTTRANSFSOL, ITEMSOLI.NRLOTEESTQ,
                                                     ITEMSOLI.NRSUBLOTE, ITEMSOLI.CDPRODPROD, ITEMSOLI.CDFILLANCONS, ITEMSOLI.CDFILSOLCONS,
                                                     ITEMSOLI.NRSOLCMPCONS, ITEMSOLI.CDPRODUTCONS, ITEMSOLI.DTPROGENCONS, ITEMSOLI.CDMARCA,
                                                     ITEMSOLI.CDRASTRITM, PRODUTO.VRFATOCONV
                                                FROM ITEMSOLI, PRODUTO
                                               WHERE ITEMSOLI.CDFILSOLI   = C_ITEM.CDFILDEST
                                                 AND ITEMSOLI.DTPROGENTR  = C_ITEM.DTENTRITMSOL
                                                 AND PRODUTO.CDPRODESTO   = C_ITEM.CDPRODESTO
                                                 AND ITEMSOLI.CDPRODUTO   = PRODUTO.CDPRODUTO
                                                 AND NVL(ITEMSOLI.IDSOLIAPROV, 'S') = 'S') LOOP
                           /*Consulta existencia de item de ruptura na solicitacao de compras origem*/
                           V_QTSOLIPRODRUP := (C_ITMSOL_ORIG.QTSOLIPROD*C_ITMSOL_ORIG.VRFATOCONV)/V_VRFATOCONVRUP;
                           SELECT NVL(MAX(QTSOLIPROD), 0)
                             INTO V_QTSOLIPROD
                             FROM ITEMSOLI
                            WHERE ITEMSOLI.CDFILSOLI  = C_ITMSOL_ORIG.CDFILSOLI
                              AND ITEMSOLI.CDFILLAN   = C_ITMSOL_ORIG.CDFILLAN
                              AND ITEMSOLI.NRSOLICMP  = C_ITMSOL_ORIG.NRSOLICMP
                              AND ITEMSOLI.CDPRODUTO  = V_CDPRODESTORUP
                              AND ITEMSOLI.DTPROGENTR = C_ITMSOL_ORIG.DTPROGENTR;

                           IF V_QTSOLIPROD = 0 THEN
                              /*Inclui item de ruptura nna solicitacao origem*/
                              INSERT
                                INTO ITEMSOLI(CDFILSOLI, CDFILLAN, NRSOLICMP, CDPRODUTO,
                                              DTPROGENTR, QTSOLIPROD, DTUTILIZA, IDITMCONS,
                                              TXOBSITMSOL, IDBAIXITMSOL, QTTRANSFSOL, NRLOTEESTQ,
                                              NRSUBLOTE, CDPRODPROD, CDFILLANCONS, CDFILSOLCONS,
                                              NRSOLCMPCONS, CDPRODUTCONS, DTPROGENCONS, CDMARCA,
                                              CDRASTRITM)
                              VALUES (C_ITMSOL_ORIG.CDFILSOLI, C_ITMSOL_ORIG.CDFILLAN, C_ITMSOL_ORIG.NRSOLICMP, V_CDPRODESTORUP,
                                     C_ITEM.DTENTRITMSOL, V_QTSOLIPRODRUP, C_ITMSOL_ORIG.DTUTILIZA, C_ITMSOL_ORIG.IDITMCONS,
                                     C_ITMSOL_ORIG.TXOBSITMSOL, C_ITMSOL_ORIG.IDBAIXITMSOL, C_ITMSOL_ORIG.QTTRANSFSOL, C_ITMSOL_ORIG.NRLOTEESTQ,
                                     C_ITMSOL_ORIG.NRSUBLOTE, C_ITMSOL_ORIG.CDPRODPROD, C_ITMSOL_ORIG.CDFILLANCONS, C_ITMSOL_ORIG.CDFILSOLCONS,
                                     C_ITMSOL_ORIG.NRSOLCMPCONS, C_ITMSOL_ORIG.CDPRODUTCONS, C_ITMSOL_ORIG.DTPROGENCONS, C_ITMSOL_ORIG.CDMARCA,
                                     C_ITMSOL_ORIG.CDRASTRITM);
                              V_QTANTOPER := 0;
                              V_QTDEPOPER := V_QTSOLIPRODRUP;
                           ELSE
                              /*Atualiza item de ruptura na solicitacao origem*/
                              UPDATE ITEMSOLI
                                 SET ITEMSOLI.QTSOLIPROD = ITEMSOLI.QTSOLIPROD + V_QTSOLIPRODRUP
                               WHERE ITEMSOLI.CDFILSOLI  = C_ITMSOL_ORIG.CDFILSOLI
                                 AND ITEMSOLI.CDFILLAN   = C_ITMSOL_ORIG.CDFILLAN
                                 AND ITEMSOLI.NRSOLICMP  = C_ITMSOL_ORIG.NRSOLICMP
                                 AND ITEMSOLI.CDPRODUTO  = V_CDPRODESTORUP
                                 AND ITEMSOLI.DTPROGENTR = C_ITEM.DTENTRITMSOL;
                              V_QTANTOPER := V_QTSOLIPROD;
                              V_QTDEPOPER := V_QTSOLIPROD + V_QTSOLIPRODRUP;

                           END IF;
                           /*Log de item de ruptura na solicitacao origem*/
                           V_DSJUSTOPER := 'Migrao de Ruptura do OL - Qtde de '||TO_CHAR(V_QTANTOPER, '9999999999999D99MI')||' para '||
                                            TO_CHAR(V_QTDEPOPER, '9999999999999D99MI');
                           INSERT
                             INTO MOVOPSOL (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO,
                                            DTENTROPER, DTOPERSOL, CDOPERADOR, QTANTOPER, QTDEPOPER,
                                            DSJUSTOPER, DSRDMUSUMOVS, DSENDUSUMOVS, DSNMUSUMOVS, DSMETUSUMOVS)
                           VALUES (C_ITMSOL_ORIG.CDFILSOLI, C_ITMSOL_ORIG.CDFILLAN, C_ITMSOL_ORIG.NRSOLICMP, C_ITMSOL_ORIG.CDPRODUTO,
                                  C_ITMSOL_ORIG.DTPROGENTR, SYSDATE, V_CDOPELOGITAF, V_QTANTOPER, V_QTDEPOPER,
                                  V_DSJUSTOPER, V_DSRDMUSLITAF, V_DSENDUSLITAF, V_DSNMUSULITAF, V_DSMETUSLITAF);
                           /*Excluir item de solicitacao origem*/
                           DELETE
                             FROM ITEMSOLI
                            WHERE ITEMSOLI.CDFILSOLI  = C_ITMSOL_ORIG.CDFILSOLI
                              AND ITEMSOLI.CDFILLAN   = C_ITMSOL_ORIG.CDFILLAN
                              AND ITEMSOLI.NRSOLICMP  = C_ITMSOL_ORIG.NRSOLICMP
                              AND ITEMSOLI.CDPRODUTO  = C_ITMSOL_ORIG.CDPRODUTO
                              AND ITEMSOLI.DTPROGENTR = C_ITMSOL_ORIG.DTPROGENTR;
                              /*Log de exclusao de item de solicitacao origem*/
                              V_DSJUSTOPER := 'Migrao de Ruptura do OL - Qtde de '||TO_CHAR(C_ITMSOL_ORIG.QTSOLIPROD, '9999999999999D99MI')||' para '||
                                              '0,00.';
                              INSERT
                                INTO MOVOPSOL (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV, CDPRODUTO,
                                               DTENTROPER, DTOPERSOL, CDOPERADOR, QTANTOPER, QTDEPOPER,
                                               DSJUSTOPER, DSRDMUSUMOVS, DSENDUSUMOVS, DSNMUSUMOVS, DSMETUSUMOVS)
                              VALUES (C_ITMSOL_ORIG.CDFILSOLI, C_ITMSOL_ORIG.CDFILLAN, C_ITMSOL_ORIG.NRSOLICMP, C_ITMSOL_ORIG.CDPRODUTO,
                                     C_ITMSOL_ORIG.DTPROGENTR, SYSDATE, V_CDOPELOGITAF, C_ITMSOL_ORIG.QTSOLIPROD, 0,
                                     V_DSJUSTOPER, V_DSRDMUSLITAF, V_DSENDUSLITAF, V_DSNMUSULITAF, V_DSMETUSLITAF);
                        END LOOP;

                        /****************************DELETA ITEM DE AF ORIGEM********************************/
                        DELETE ITEMAUTF
                         WHERE ITEMAUTF.CDFILDEST   = C_ITEM.CDFILDEST
                           AND ITEMAUTF.CDFILLANC   = C_ITEM.CDFILLANC
                           AND ITEMAUTF.NRAUTOFORN  = C_ITEM.NRAUTOFORN
                           AND ITEMAUTF.CDPRODUTO   = C_ITEM.CDPRODUTO
                           AND ITEMAUTF.CDMARCA     = C_ITEM.CDMARCA
                           AND ITEMAUTF.DTPROGENTAF = C_ITEM.DTPROGENTAF;
                     END IF;
                  ELSIF C_ITEM.IDTPGERARUP = 'P' THEN
                     UPDATE ITEMAUTF
                        SET IDTPGERARUP   = 'P',
                            QTATENDPEDOL  = 0,
                            IDITMSEPARADO = 'N',
                            IDBAIXITMAF   = '3',
                            QTNOVAPROGAF  = QTPROGENTAF,
                            QTPROGENTAF   = 0,
                            IDITAFMIGRADA = 'S',
                            CDPRODRUP     = NULL,
                            CDMARCARUP    = NULL,
                            VRPREUNIRUP   = 0
                      WHERE CDFILDEST     = C_ITEM.CDFILDEST
                        AND CDFILLANC     = C_ITEM.CDFILLANC
                        AND NRAUTOFORN    = C_ITEM.NRAUTOFORN
                        AND CDMARCA       = C_ITEM.CDMARCA
                        AND CDPRODUTO     = C_ITEM.CDPRODUTO
                        AND DTPROGENTAF   = C_ITEM.DTPROGENTAF;
                     UPDATE ITEMSOLI
                        SET IDITEMRUPTURA  = 'P',
                            NRSEQRUPTURAOL = C_RUPTURAOL.NRSEQRUPTURAOL
                      WHERE CDFILSOLI      = C_ITEM.CDFILDEST
                        AND DTPROGENTR     = C_ITEM.DTENTRITMSOL
                        AND CDPRODUTO  IN (SELECT CDPRODUTO FROM PRODUTO WHERE CDPRODESTO = C_ITEM.CDPRODESTO);
                     IF NVL(V_CDPRODINI, '99999999999999999999') > C_ITEM.CDARVPROD THEN
                        V_CDPRODINI := SUBSTR(C_ITEM.CDARVPROD, 1, LENGTH(C_ITEM.CDARVPROD)-2);
                     END IF;
                     IF NVL(V_CDPRODFIN, '0') < C_ITEM.CDARVPROD THEN
                        V_CDPRODFIN := SUBSTR(C_ITEM.CDARVPROD, 1, LENGTH(C_ITEM.CDARVPROD)-2);
                     END IF;
                     IF NVL(V_DTENTRINI, '31/12/9999') > C_ITEM.DTPROGENTAF THEN
                        V_DTENTRINI := C_ITEM.DTPROGENTAF;
                     END IF;
                     IF NVL(V_DTENTRFIN, '01/01/1000') < C_ITEM.DTPROGENTAF THEN
                        V_DTENTRFIN := C_ITEM.DTPROGENTAF;
                     END IF;
                     IF V_ITEM_NOVA_AP = 0 THEN
                        V_LISTA_FILIAL := '_'||C_ITEM.CDFILDEST;
                     ELSE
                        IF INSTR(V_LISTA_FILIAL||'_', C_ITEM.CDFILDEST) = 0 THEN
                           V_LISTA_FILIAL := V_LISTA_FILIAL||'_'||C_ITEM.CDFILDEST;
                        END IF;
                     END IF;
                     V_ITEM_NOVA_AP := 1;
                  END IF;
               END LOOP;
               IF V_ITEM_NOVA_AP >= 1 THEN
                  V_LISTA_FILIAL := V_LISTA_FILIAL||'_';
                  V_CDPRODFIN    := RPAD(V_CDPRODFIN, 20, 'Z');
                  V_DTENTRINI    := V_DTENTRINI;
                  V_LISTA_COMP   := '';
                  V_AFS_GERADAS     := 0;
                  FOR C_COMPRADOR IN(SELECT DISTINCT AUTOFORNE.CDOPERADOR
                                       FROM AUTOFORNE
                                      WHERE INSTR(V_LISTA_FILIAL, AUTOFORNE.CDFILDEST) > 0
                                        AND NVL(AUTOFORNE.CDFILIOPELOG, 'W')  = C_RUPTURAOL.CDFILIAL
                                        AND EXISTS(SELECT 1
                                                     FROM ITEMAUTF, PRODUTO
                                                    WHERE ITEMAUTF.CDFILDEST = AUTOFORNE.CDFILDEST
                                                      AND ITEMAUTF.CDFILLANC = AUTOFORNE.CDFILLANC
                                                      AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN
                                                      AND ITEMAUTF.CDPRODUTO  = PRODUTO.CDPRODUTO
                                                      AND INSTR(V_LISTA_FILIAL, ITEMAUTF.CDFILDEST) > 0
                                                      AND NVL(ITEMAUTF.NRSEQRUPTURAOL, 'W') = C_RUPTURAOL.NRSEQRUPTURAOL
                                                      AND PRODUTO.CDARVPROD BETWEEN V_CDPRODINI AND V_CDPRODFIN
                                                      AND ITEMAUTF.DTPROGENTAF BETWEEN V_DTENTRINI  AND V_DTENTRFIN
                                                      AND NVL(ITEMAUTF.IDTPGERARUP, 'N')    = 'P'
                                                      AND NVL(ITEMAUTF.QTATENDPEDOL, 0)     =  0
                                                      AND NVL(ITEMAUTF.IDITMSEPARADO, 'N')  = 'N')) LOOP
                     V_NRSEQAPUR := 'A' || C_RUPTURAOL.CDFILIAL || SUBSTR(C_COMPRADOR.CDOPERADOR, 8, 5);
                     V_ROWSAFFECT := 'N';
                     APURA_EFETIVACAO(V_CDFILCENTCMP,
                                      V_NRSEQAPUR,
                                      V_CDPRODINI,
                                      V_CDPRODFIN,
                                      V_DTENTRINI-30,
                                      V_DTENTRFIN+30,
                                      C_COMPRADOR.CDOPERADOR,
                                      '',
                                      '',
                                      TO_DATE(TRUNC(SYSDATE)),
                                      V_CDFILCENTCMP,
                                      '',
                                      'ALL_ROWS',
                                      V_ROWSAFFECT,
                                      V_CDOPELOGITAF,
                                      C_COMPRADOR.CDOPERADOR,
                                      V_LISTA_FILIAL,
                                      'N',
                                      NULL,
                                      'N',
                                      'P',
                                      C_RUPTURAOL.NRSEQRUPTURAOL);
                     APURA_MELHOR_COTACAO(V_CDFILCENTCMP, V_NRSEQAPUR, 'SUP', 'A');
                     EFETIVAR_AF(C_COMPRADOR.CDOPERADOR,
                                 TO_DATE(TRUNC(SYSDATE)),
                                 V_CDFILCENTCMP,
                                 V_NRSEQAPUR,
                                 V_CDFILCENTCMP,
                                 C_RUPTURAOL.CDFILIAL,
                                 C_RUPTURAOL.NRSEQRUPTURAOL);
                     IF V_ROWSAFFECT = 'N' THEN
                        UPDATE LOGRUPTURAOLAUT
                           SET DSPROCESSO = 'APURACAO',
                               DSERRO     = 'NAO_HA_DADOS',
                               DTOPERACAO = SYSDATE
                         WHERE NRLOGRUPTURAOLAUT = V_NRLOGRUPTURAOLAUT;
                         P_STATUS := 'NAO_HA_DADOS';
                     ELSE
                        V_LISTA_COMP  := V_LISTA_COMP||'_'||C_COMPRADOR.CDOPERADOR;
                        V_AFS_GERADAS := V_AFS_GERADAS + 1;
                     END IF;
                  END LOOP;
                  IF V_AFS_GERADAS > 0 THEN
                     FOR C_FORNECEDOR IN (SELECT DISTINCT E.CDFORNECED,  NVL(E.IDTPENVAFNORMAL, 'E') IDTPENVAFNORMAL
                                            FROM AUTOFORNE, FORNECEDOR, FORNECEDOR E
                                           WHERE AUTOFORNE.CDFORNECED  = FORNECEDOR.CDFORNECED
                                             AND E.CDFORNECED  = NVL(FORNECEDOR.CDFORNERELACAF, FORNECEDOR.CDFORNECED)
                                             AND INSTR(V_LISTA_FILIAL, AUTOFORNE.CDFILDEST) > 0
                                             AND INSTR(V_LISTA_COMP, AUTOFORNE.CDOPERADOR) > 0
                                             AND AUTOFORNE.DTAUTOFORN =  TO_DATE(TRUNC(SYSDATE))
                                             AND NVL(AUTOFORNE.NRSEQAPURAF, 'W') = V_NRSEQAPUR
                                             AND AUTOFORNE.IDTIPOLANCAF = 'A'
                                             AND EXISTS(SELECT 1
                                                          FROM ITEMAUTF, PRODUTO
                                                         WHERE ITEMAUTF.CDFILDEST  = AUTOFORNE.CDFILDEST
                                                           AND ITEMAUTF.CDFILLANC  = AUTOFORNE.CDFILLANC
                                                           AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN
                                                           AND INSTR(V_LISTA_FILIAL, ITEMAUTF.CDFILDEST) > 0
                                                           AND ITEMAUTF.CDPRODUTO  = PRODUTO.CDPRODUTO
                                                           AND NVL(ITEMAUTF.NRSEQRUPTURAOL, 'W') = 'W'
                                                           AND PRODUTO.CDARVPROD BETWEEN V_CDPRODINI AND V_CDPRODFIN
                                                           AND ITEMAUTF.DTPROGENTAF BETWEEN V_DTENTRINI - 15 AND V_DTENTRFIN
                                                           AND NVL(ITEMAUTF.IDUTLITEMRUPTURA, 'N') = 'S')
                                           ORDER BY E.CDFORNECED) LOOP
                           V_LISTA_AF    := '';
                           V_LISTA_TAF   := '';
                           V_CONTA_PORTAL:= 0;
                        FOR C_AUTOFORNE IN (SELECT DISTINCT AUTOFORNE.CDFILDEST, AUTOFORNE.CDFILLANC, AUTOFORNE.NRAUTOFORN,
                                                   E.CDFORNECED
                                              FROM AUTOFORNE, FORNECEDOR, FORNECEDOR E
                                             WHERE INSTR(V_LISTA_COMP, AUTOFORNE.CDOPERADOR) > 0
                                               AND INSTR(V_LISTA_FILIAL, AUTOFORNE.CDFILDEST) > 0
                                               AND AUTOFORNE.DTAUTOFORN =  TO_DATE(TRUNC(SYSDATE))
                                               AND NVL(AUTOFORNE.NRSEQAPURAF, 'W') = V_NRSEQAPUR
                                               AND AUTOFORNE.IDTIPOLANCAF = 'A'
                                               AND AUTOFORNE.CDFORNECED  = FORNECEDOR.CDFORNECED
                                               AND E.CDFORNECED  = NVL(FORNECEDOR.CDFORNERELACAF, FORNECEDOR.CDFORNECED)
                                               AND E.CDFORNECED         = C_FORNECEDOR.CDFORNECED
                                               AND EXISTS(SELECT 1
                                                            FROM ITEMAUTF, PRODUTO
                                                           WHERE ITEMAUTF.CDFILDEST  = AUTOFORNE.CDFILDEST
                                                             AND ITEMAUTF.CDFILLANC  = AUTOFORNE.CDFILLANC
                                                             AND ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN
                                                             AND INSTR(V_LISTA_FILIAL, ITEMAUTF.CDFILDEST) > 0
                                                             AND ITEMAUTF.CDPRODUTO  = PRODUTO.CDPRODUTO
                                                             AND NVL(ITEMAUTF.NRSEQRUPTURAOL, 'W') = 'W'
                                                             AND NVL(ITEMAUTF.IDUTLITEMRUPTURA, 'N') = 'S'
                                                             AND NVL(ITEMAUTF.CDFILDESTORIG, 'N') = ITEMAUTF.CDFILDEST
                                                             AND PRODUTO.CDARVPROD BETWEEN V_CDPRODINI AND V_CDPRODFIN
                                                             AND ITEMAUTF.DTPROGENTAF BETWEEN V_DTENTRINI - 15 AND V_DTENTRFIN
                                                             AND NVL(ITEMAUTF.IDUTLITEMRUPTURA, 'N') = 'S')) LOOP
                           FECHA_AUTOFORNE_MOBILE(C_AUTOFORNE.CDFILDEST, C_AUTOFORNE.CDFILLANC, C_AUTOFORNE.NRAUTOFORN, V_SEM_ERRO);
                           IF V_SEM_ERRO = 'S' THEN
                              V_CONTA_PORTAL  := V_CONTA_PORTAL  + 1;
                              V_CONTA_PORTALT := V_CONTA_PORTALT + 1;
                              V_LISTA_AF := C_AUTOFORNE.NRAUTOFORN||', '||V_LISTA_AF;
                           ELSE
                              SELECT COUNT(1)
                                INTO V_CONTA_FORN
                                FROM LOGRUPTURAOLAUT
                               WHERE NVL(CDFORNECED, 'W') = 'W'
                                 AND NRLOGRUPTURAOLAUT = V_NRLOGRUPTURAOLAUT;
                              IF V_CONTA_FORN > 0 THEN
                                 UPDATE LOGRUPTURAOLAUT
                                    SET DSPROCESSO = 'GERACAO_AF',
                                        DSERRO     = 'INCONSISTENTE',
                                        DTOPERACAO = SYSDATE,
                                        LISTAAF    = C_AUTOFORNE.NRAUTOFORN||', '||LISTAAF,
                                        CDFORNECED = C_FORNECEDOR.CDFORNECED
                                  WHERE NRLOGRUPTURAOLAUT = V_NRLOGRUPTURAOLAUT
                                    AND NRSEQRUPTURAOL    = C_RUPTURAOL.NRSEQRUPTURAOL
                                    AND CDFILIAL          = C_RUPTURAOL.CDFILIAL;
                              ELSE
                                 SELECT COUNT(1)
                                   INTO V_CONTA_FORN
                                   FROM LOGRUPTURAOLAUT
                                  WHERE NRSEQRUPTURAOL    = C_RUPTURAOL.NRSEQRUPTURAOL
                                    AND CDFILIAL          = C_RUPTURAOL.CDFILIAL
                                    AND CDFORNECED        = C_FORNECEDOR.CDFORNECED;
                                 IF V_CONTA_FORN > 0 THEN
                                    UPDATE LOGRUPTURAOLAUT
                                    SET DSPROCESSO = 'GERACAO_AF',
                                        DSERRO     = 'INCONSISTENTE',
                                        DTOPERACAO = SYSDATE,
                                        LISTAAF    = C_AUTOFORNE.NRAUTOFORN||', '||LISTAAF,
                                        CDFORNECED = C_FORNECEDOR.CDFORNECED
                                  WHERE NRLOGRUPTURAOLAUT = V_NRLOGRUPTURAOLAUT
                                    AND NRSEQRUPTURAOL    = C_RUPTURAOL.NRSEQRUPTURAOL
                                    AND CDFILIAL          = C_RUPTURAOL.CDFILIAL
                                    AND CDFORNECED = C_FORNECEDOR.CDFORNECED;
                                 ELSE
                                    V_NRLOGRUPTURAOLAUT := SEQ_NRLOGRUPTURAOLAUT.NEXTVAL;
                                    INSERT
                                      INTO LOGRUPTURAOLAUT(NRLOGRUPTURAOLAUT, NRSEQRUPTURAOL, CDFILIAL, DTOPERACAO,
                                                           DSPROCESSO, DSERRO, LISTAAF, CDFORNECED)
                                    VALUES (V_NRLOGRUPTURAOLAUT, C_RUPTURAOL.NRSEQRUPTURAOL, C_RUPTURAOL.CDFILIAL, SYSDATE,
                                            'GERACAO_AF', 'INCONSISTENTE', C_AUTOFORNE.NRAUTOFORN||', ',
                                            C_FORNECEDOR.CDFORNECED);
                                 END IF;
                              END IF;
                              P_STATUS := 'INCONSISTENTE';
                           END IF;
                           V_LISTA_TAF := C_AUTOFORNE.NRAUTOFORN||'_'||V_LISTA_TAF;
                        END LOOP;
                        V_ENVIOAFFORN := '';
                        IF C_FORNECEDOR.IDTPENVAFNORMAL = 'P' THEN
                           NOVO_CODIGO_NT('ENVIOAFFORN', V_ENVIOAFFORN, 1);
                           V_ENVIOAFFORN := SUBSTR(V_ENVIOAFFORN, 11, 10);
                           IF (INSTR(V_LISTA_ENVIOAFFORN, V_ENVIOAFFORN) <= 0) THEN
                              V_LISTA_ENVIOAFFORN := V_LISTA_ENVIOAFFORN||'_'||V_ENVIOAFFORN;
                           END IF;
                           INSERT
                             INTO ENVIOAFFORN
                                  (NRSEQENVIOAFORN, CDFORNECED, CDPAIS, SGESTADO, DTINIAPURAFFORN,
                                  DTFINAPURAFFORN, DTENVIOAFFORN, QTAFSENVIOFOR, QTAFSNENVFOR, IDTIPENVLIDO,
                                  IDTIPENVAFFORN, DSARQENVIOAF, CDOPERINCLUSAO, DTENTREGAFFORN,
                                  LISTNRSEQAPUR, IDUTILSMTP, DSEXTENSAO, IDTCLASSENVAFOR)
                           SELECT V_ENVIOAFFORN, F.CDFORNECED, E.CDPAIS, E.SGESTADO, V_DTENTRINI,
                                  V_DTENTRFIN, TO_DATE(TRUNC(SYSDATE)), V_CONTA_PORTAL, 0, 'N',
                                  NVL(F.IDTPENVAFNORMAL, 'E'), '', V_CDOPELOGITAF, V_DTENTRFIN,
                                  V_NRSEQAPUR, 'S', 'PDF', 'N'
                              FROM FORNECEDOR F, ENDEFORN E
                             WHERE F.CDFORNECED   = C_FORNECEDOR.CDFORNECED
                               AND F.CDFORNECED   = E.CDFORNECED
                               AND E.IDTPENDEFORN = 'P';
                        END IF;
                        UPDATE AUTOFORNE
                           SET NRSEQENVIOAFORN = V_ENVIOAFFORN,
                               IDBAIXAAF       = NULL,
                               NRSEQAPURAF     = NULL
                         WHERE INSTR(V_LISTA_TAF, NRAUTOFORN) > 0
                           AND INSTR(V_LISTA_FILIAL, CDFILDEST) > 0
                           AND NVL(IDSITUATUAAF, '0') = '0'
                           AND NVL(IDAFFORALIM, 'N')  = 'N';
                     END LOOP;
                  END IF;
               END IF;
               UPDATE RUPTURAOL
                  SET IDSITUACAO     = 'C',
                      DATAINI        = V_DTENTRINI-15,
                      DATAFIN        = V_DTENTRFIN,
                      PRODINI        = V_CDPRODINI,
                      PRODFIN        = V_CDPRODFIN,
                      LISTCDOPERADOR = V_LISTA_COMP,
                      LISTCDFILDEST  = V_LISTA_FILIAL,
                      LISTA_ENVIOAFFORN = V_LISTA_ENVIOAFFORN
                WHERE CDFILIAL       = C_RUPTURAOL.CDFILIAL
                  AND NRSEQRUPTURAOL = C_RUPTURAOL.NRSEQRUPTURAOL;
            END IF;
         END LOOP;
      END LOOP;
   EXCEPTION
     WHEN OTHERS THEN BEGIN
        ROLLBACK;
        P_STATUS := 'ERRO_ORA';
        V_ERROR:= SUBSTR(SQLERRM(SQLCODE), 1, 2000);
        INSERT
          INTO LOGRUPTURAOLAUT(NRLOGRUPTURAOLAUT, NRSEQRUPTURAOL, CDFILIAL,
                             DTOPERACAO, DSPROCESSO, DSERRO)
            VALUES (V_NRLOGRUPTURAOLAUT, V_NRSEQRUPTURAOL, V_CDFILIAL,
                    SYSDATE, 'CONCLUSAO_RUPTURA_GERA_AF', SUBSTR(V_ERROR, 1, 2000));
        COMMIT;
     END;
  END;
  IF V_CONTA_PORTALT > 0 THEN
     IF LENGTH(V_DSURLCONCLAUTRUPOL) > 0 THEN
        BEGIN
           SELECT SUBSTR(UTL_HTTP.REQUEST(V_DSURLCONCLAUTRUPOL), 1, 1000)
             INTO V_RETORNO
             FROM DUAL;
        EXCEPTION
            WHEN OTHERS THEN BEGIN
               V_RETORNO := '';
            END;
        END;
     END IF;
     P_STATUS := V_DSURLCONCLAUTRUPOL;
  END IF;
END;
/

BEGIN
   DBMS_SCHEDULER.DROP_JOB (job_name => 'JOB_CONCLUI_MIGRACAO_OL');
END;
/

BEGIN
   DBMS_SCHEDULER.CREATE_JOB (
      JOB_NAME   =>  'JOB_CONCLUI_MIGRACAO_OL',
      JOB_TYPE   =>  'PLSQL_BLOCK',
      JOB_ACTION =>  'DECLARE
                        V_STATUS VARCHAR2(2000);
                        V_RETORNO VARCHAR2(2000);
                        BEGIN
                           CONCLUI_MIGRACAO_OL(V_STATUS);
                           COMMIT;
                           IF LENGTH(V_STATUS) > 0 THEN
                              SELECT SUBSTR(UTL_HTTP.REQUEST(V_STATUS), 1, 2000)
                                INTO V_RETORNO
                                FROM DUAL;
                           END IF;
                        END;',
      START_DATE =>  systimestamp +(60-TO_NUMBER(TO_CHAR(SYSDATE, 'MI')))/(24*60),
      repeat_interval => 'FREQ=HOURLY',
      JOB_CLASS  =>  '"DEFAULT_JOB_CLASS"',
      ENABLED    => TRUE,
      AUTO_DROP  => FALSE,
      COMMENTS   =>  '');
END;
/